"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.jsonParse = exports.hmacSha256 = exports.decryptData = exports.encryptData = exports.generateSymmetricKey = exports.issueCryptoToken = exports.issueToken = void 0;
var axios_1 = require("axios");
var _ = require("lodash");
var CryptoJS = require("crypto-js");
var nice_error_1 = require("../models/nice-error");
require("../extensions/date.extensions");
function issueToken() {
    return __awaiter(this, void 0, void 0, function () {
        var params, response, dataHeader, dataBody, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    params = new URLSearchParams();
                    params.append('grant_type', 'client_credentials');
                    params.append('scope', 'default');
                    return [4 /*yield*/, axios_1.default.post('https://svc.niceapi.co.kr:22001/digital/niceid/oauth/oauth/token', params, {
                            headers: {
                                'Content-Type': 'application/x-www-form-urlencoded',
                                'Authorization': 'Basic ' + Buffer.from("".concat(this._options.clientId, ":").concat(this._options.clientSecret)).toString('base64'),
                            },
                        })];
                case 1:
                    response = _a.sent();
                    dataHeader = _.get(response, 'data.dataHeader') || {};
                    dataBody = _.get(response, 'data.dataBody') || {};
                    if (dataHeader.GW_RSLT_CD !== '1200' || !dataBody.access_token) {
                        throw new nice_error_1.AccessTokenError();
                    }
                    return [2 /*return*/, {
                            accessToken: dataBody.access_token,
                            tokenType: dataBody.token_type,
                            expiresIn: dataBody.expires_in,
                            scope: dataBody.scope,
                        }];
                case 2:
                    e_1 = _a.sent();
                    throw new nice_error_1.AccessTokenError((e_1 && e_1.message) || 'Failed to issue access token');
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.issueToken = issueToken;
function issueCryptoToken(requestno, accessToken, nowDate) {
    return __awaiter(this, void 0, void 0, function () {
        var currentTimestamp, Authorization, response, dataHeader, dataBody, e_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    currentTimestamp = Math.round(nowDate.valueOf() / 1000);
                    Authorization = 'bearer ' + Buffer.from("".concat(accessToken, ":").concat(currentTimestamp, ":").concat(this._options.clientId)).toString('base64');
                    return [4 /*yield*/, axios_1.default.post('https://svc.niceapi.co.kr:22001/digital/niceid/api/v1.0/common/crypto/token', {
                            dataHeader: { CNTY_CD: 'ko' },
                            dataBody: {
                                req_dtim: nowDate.YYYYMMDDHHmmss(),
                                req_no: requestno,
                                enc_mode: '1',
                            },
                        }, {
                            headers: {
                                'Content-Type': 'application/json',
                                Authorization: Authorization,
                                'client_id': this._options.clientId,
                                'ProductID': this._options.productId,
                            },
                        })];
                case 1:
                    response = _a.sent();
                    dataHeader = _.get(response, 'data.dataHeader') || {};
                    dataBody = _.get(response, 'data.dataBody') || {};
                    if (dataHeader.GW_RSLT_CD !== '1200' || dataBody.rsp_cd !== 'P000' || dataBody.result_cd !== '0000') {
                        throw new nice_error_1.CryptoTokenError();
                    }
                    return [2 /*return*/, {
                            cryptoToken: dataBody.token_val.trim(),
                            siteCode: dataBody.site_code,
                            tokenVersionId: dataBody.token_version_id,
                        }];
                case 2:
                    e_2 = _a.sent();
                    throw new nice_error_1.CryptoTokenError((e_2 && e_2.message) || 'Failed to issue crypto token');
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.issueCryptoToken = issueCryptoToken;
function generateSymmetricKey(requestno, cryptoToken, now) {
    try {
        if (!requestno || !cryptoToken || !now) {
            throw new nice_error_1.SymmetricKeyError();
        }
        var hash = CryptoJS.SHA256("".concat(now.YYYYMMDDHHmmss()).concat(requestno).concat(cryptoToken));
        var symmetricKey = CryptoJS.enc.Base64.stringify(hash);
        if (!symmetricKey) {
            throw new nice_error_1.SymmetricKeyError('Symmetric key base64 encoding failed');
        }
        return {
            symmetricKey: symmetricKey,
            key: symmetricKey.substring(0, 16),
            iv: symmetricKey.substring(symmetricKey.length - 16),
            hmacKey: symmetricKey.substring(0, 32),
        };
    }
    catch (e) {
        throw new nice_error_1.SymmetricKeyError((e && e.message) || 'Symmetric key generation failed');
    }
}
exports.generateSymmetricKey = generateSymmetricKey;
function encryptData(key, iv, plainData) {
    try {
        var cipher = CryptoJS.AES.encrypt(plainData, CryptoJS.enc.Utf8.parse(key), {
            iv: CryptoJS.enc.Utf8.parse(iv),
            padding: CryptoJS.pad.Pkcs7,
            mode: CryptoJS.mode.CBC,
        });
        var cipherData = cipher && cipher.ciphertext && cipher.ciphertext.toString(CryptoJS.enc.Base64);
        if (!cipherData) {
            throw new nice_error_1.EncryptDataError();
        }
        return cipherData;
    }
    catch (e) {
        throw new nice_error_1.EncryptDataError((e && e.message) || 'Request data encryption failed');
    }
}
exports.encryptData = encryptData;
function decryptData(key, iv, cipherData) {
    return CryptoJS.AES.decrypt(cipherData, CryptoJS.enc.Utf8.parse(key), {
        iv: CryptoJS.enc.Utf8.parse(iv),
        padding: CryptoJS.pad.Pkcs7,
        mode: CryptoJS.mode.CBC,
    }).toString(CryptoJS.enc.Base64);
}
exports.decryptData = decryptData;
function hmacSha256(key, data) {
    try {
        var hmac = CryptoJS.HmacSHA256(data, key);
        var result = CryptoJS.enc.Base64.stringify(hmac);
        if (!result) {
            throw new nice_error_1.IntegrityValueError();
        }
        return result;
    }
    catch (e) {
        throw new nice_error_1.IntegrityValueError((e && e.message) || 'Integrity value generation failed');
    }
}
exports.hmacSha256 = hmacSha256;
function jsonParse(str) {
    if (!str)
        return null;
    try {
        return JSON.parse(str);
    }
    catch (ex) {
        return null;
    }
}
exports.jsonParse = jsonParse;
